#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <cstring>
#include <string>
#include <map>
#include <cmath>
#include <set>


#define FOR(i,a,b) for (int i = (a); i < (b); ++i)
#define FI(i,b) FOR(i,0,b)
#define V(t) vector < t >
#define pb push_back
#define MEMS(a,b) memset((a),(b),sizeof(a))
#define U unsigned
#define LL long long
#define pnt pair<int,int>
#define mp make_pair

using namespace std;


int n,S,t;

struct Point
{
  int x,y,z;
  Point(){};
  Point(int xx, int yy , int zz):x(xx),y(yy),z(zz){};
  void read() {scanf("%d%d%d",&x,&y,&z);}
};

bool comp(const Point &a, const Point &b)
{
  pair <int, pnt> ap = mp(a.x, mp(a.y,a.z));
  pair <int, pnt> bp = mp(b.x, mp(b.y,b.z));
  return ap < bp;
}

bool operator ==(const Point &a, const Point &b)
{
  pair <int, pnt> ap = mp(a.x, mp(a.y,a.z));
  pair <int, pnt> bp = mp(b.x, mp(b.y,b.z));
  return ap == bp;
}

Point st[1111], fin[1111];
Point pts[2222];
int pCnt;

int lNum(Point p)
{
  return lower_bound(pts,pts+pCnt,p,comp)-pts;
}
V(V(int)) G;

set < pair <double, pair<int, int>  > > s;

double d[2222][2222];

const int ignore = 2200;

double dd(Point cur, Point to)
{
  return sqrt((cur.x-to.x)*(cur.x-to.x) + (cur.y-to.y)*(cur.y-to.y) + (cur.z-to.z)*(cur.z-to.z));
}

const double pi = 4*atan(1.0);

double ang(Point prev, Point cur, Point to)
{
  Point v1(prev.x-cur.x, prev.y - cur.y, prev.z - cur.z);
  Point v2(to.x-cur.x, to.y - cur.y, to.z - cur.z);
  double scal = v1.x*v2.x + v1.y*v2.y + v1.z*v2.z;
  double cosAng = scal/dd(prev,cur)/dd(cur,to);
  return acos(cosAng)*180.0/pi;
}

double gDist(int prev, int cur, int to)
{
  if (prev == ignore)
    return dd(pts[cur],pts[to])/double(S);
  return ang(pts[prev],pts[cur],pts[to])/double(t) + dd(pts[cur],pts[to])/double(S);
}

int main()
{
  while(scanf("%d%d%d",&n,&S,&t)!=EOF)
  {
    Point start; start.read();
    Point end; end.read();
    
    
    FI(i,n) {st[i].read(); fin[i].read();}
    FI(i,n) pts[i] = st[i], pts[i+n] = fin[i];
    sort(pts,pts+2*n,comp);
    pCnt = unique(pts,pts+2*n) - pts;
    
    G.resize(pCnt);
    FI(i,n)
    {
      G[lNum(st[i])].pb( lNum(fin[i]) );
      G[lNum(fin[i])].pb( lNum(st[i]) );
    }
    
    
       
    s.clear();
    MEMS(d,-1);
    
    s.insert(mp(0, mp(lNum(start), ignore)));
    d[lNum(start)][ignore] = 0;
    
    int endInd = lNum(end);

    while (!s.empty())
    {
      
      int cur = s.begin()->second.first;
      int prev = s.begin()->second.second;
      if (cur == endInd) {printf("%.20lf\n",s.begin()->first); break;}      
      
      
      s.erase(s.begin());
      FI(i,G[cur].size())
      {	
	int to = G[cur][i];
	double dist = gDist(prev,cur,to);
	if (d[cur][prev] + dist < d[to][cur] || d[to][cur] < -0.5)
	{
	  s.erase(mp(d[to][cur], mp(to,cur)));
	  d[to][cur] = d[cur][prev] + dist;
	  s.insert(mp(d[to][cur], mp(to,cur)));
	}
      }
    }
    
  }
 
  return 0;
}